Loading...
Searching...
No Matches
juce::AudioThumbnailBase Class Referenceabstract

## Detailed Description

Provides a base for classes that can store and draw scaled views of an audio waveform.

Typically, you'll want to use the derived class AudioThumbnail, which provides a concrete implementation.

See also
  AudioThumbnail, AudioThumbnailCache

The documentation for this class was generated from the following file:

- juce_audio_utils/gui/juce_AudioThumbnailBase.h

Inheritance diagram for juce::AudioThumbnailBase:

## Public Member Functions

| AudioThumbnailBase ()=default
| ~AudioThumbnailBase () override=default
virtual void | clear ()=0
| Clears and resets the thumbnail.
virtual bool | setSource (InputSource *newSource)=0
| Specifies the file or stream that contains the audio file.
virtual void | setReader (AudioFormatReader *newReader, int64 hashCode)=0
| Gives the thumbnail an AudioFormatReader to use directly.
virtual bool | loadFrom (InputStream &input)=0
| Reloads the low res thumbnail data from an input stream.
virtual void | saveTo (OutputStream &output) const =0
| Saves the low res thumbnail data to an output stream.
virtual int | getNumChannels () const noexcept=0
| Returns the number of channels in the file.
virtual double | getTotalLength () const noexcept=0
| Returns the length of the audio file, in seconds.
virtual void | drawChannel (Graphics &g, const Rectangle< int > &area, double startTimeSeconds, double endTimeSeconds, int channelNum, float verticalZoomFactor)=0
| Draws the waveform for a channel.
virtual void | drawChannels (Graphics &g, const Rectangle< int > &area, double startTimeSeconds, double endTimeSeconds, float verticalZoomFactor)=0
| Draws the waveforms for all channels in the thumbnail.
virtual bool | isFullyLoaded () const noexcept=0
| Returns true if the low res preview is fully generated.
virtual int64 | getNumSamplesFinished () const noexcept=0
| Returns the number of samples that have been set in the thumbnail.
virtual float | getApproximatePeak () const =0
| Returns the highest level in the thumbnail.
virtual void | getApproximateMinMax (double startTime, double endTime, int channelIndex, float &minValue, float &maxValue) const noexcept=0
| Reads the approximate min and max levels from a section of the thumbnail.
virtual int64 | getHashCode () const =0
| Returns the hash code that was set by setSource() or setReader().
Public Member Functions inherited from juce::ChangeBroadcaster
| ChangeBroadcaster () noexcept
| Creates an ChangeBroadcaster.
virtual | ~ChangeBroadcaster ()
| Destructor.
void | addChangeListener (ChangeListener *listener)
| Registers a listener to receive change callbacks from this broadcaster.
void | removeChangeListener (ChangeListener *listener)
| Unregisters a listener from the list.
void | removeAllChangeListeners ()
| Removes all listeners from the list.
void | sendChangeMessage ()
| Causes an asynchronous change message to be sent to all the registered listeners.
void | sendSynchronousChangeMessage ()
| Sends a synchronous change message to all the registered listeners.
void | dispatchPendingMessages ()
| If a change message has been sent but not yet dispatched, this will call sendSynchronousChangeMessage() to make the callback immediately.
Public Member Functions inherited from juce::AudioFormatWriter::ThreadedWriter::IncomingDataReceiver
| IncomingDataReceiver ()=default
virtual | ~IncomingDataReceiver ()=default
virtual void | reset (int numChannels, double sampleRate, int64 totalSamplesInSource)=0
virtual void | addBlock (int64 sampleNumberInSource, const AudioBuffer< float > &newData, int startOffsetInBuffer, int numSamples)=0

## Constructors and Destructors

## AudioThumbnailBase()

juce::AudioThumbnailBase::AudioThumbnailBase | ( |  | ) |

default

## ~AudioThumbnailBase()

juce::AudioThumbnailBase::~AudioThumbnailBase | ( |  | ) |

override default

## Member Functions

## clear()

virtual void juce::AudioThumbnailBase::clear | ( |  | ) |

pure virtual

Clears and resets the thumbnail.

Implemented in juce::AudioThumbnail.

## setSource()

virtual bool juce::AudioThumbnailBase::setSource | ( | InputSource * | newSource | ) |

pure virtual

Specifies the file or stream that contains the audio file.

For a file, just call

setSource (new FileInputSource (file))
juce::AudioThumbnailBase::setSource
virtual bool setSource(InputSource *newSource)=0
Specifies the file or stream that contains the audio file.
juce::FileInputSource
A type of InputSource that represents a normal file.
Definition juce_FileInputSource.h:47

You can pass a nullptr in here to clear the thumbnail. The source that is passed in will be deleted by this object when it is no longer needed.

Returns
  true if the source could be opened as a valid audio file, false if this failed for some reason.

Implemented in juce::AudioThumbnail.

## setReader()

virtual void juce::AudioThumbnailBase::setReader | ( | AudioFormatReader * | newReader,
|  | int64 | hashCode )

pure virtual

Gives the thumbnail an AudioFormatReader to use directly.

This will start parsing the audio in a background thread (unless the hash code can be looked-up successfully in the thumbnail cache). Note that the reader object will be held by the thumbnail and deleted later when no longer needed. The thumbnail will actually keep hold of this reader until you clear the thumbnail or change the input source, so the file will be held open for all this time. If you don't want the thumbnail to keep a file handle open continuously, you should use the setSource() method instead, which will only open the file when it needs to.

Implemented in juce::AudioThumbnail.

## loadFrom()

virtual bool juce::AudioThumbnailBase::loadFrom | ( | InputStream & | input | ) |

pure virtual

Reloads the low res thumbnail data from an input stream.

This is not an audio file stream! It takes a stream of thumbnail data that would previously have been created by the saveTo() method.

See also
  saveTo

Implemented in juce::AudioThumbnail.

## saveTo()

virtual void juce::AudioThumbnailBase::saveTo | ( | OutputStream & | output | ) | const

pure virtual

Saves the low res thumbnail data to an output stream.

The data that is written can later be reloaded using loadFrom().

See also
  loadFrom

Implemented in juce::AudioThumbnail.

## getNumChannels()

virtual int juce::AudioThumbnailBase::getNumChannels | ( |  | ) | const

pure virtual noexcept

Returns the number of channels in the file.

Implemented in juce::AudioThumbnail.

## getTotalLength()

virtual double juce::AudioThumbnailBase::getTotalLength | ( |  | ) | const

pure virtual noexcept

Returns the length of the audio file, in seconds.

Implemented in juce::AudioThumbnail.

References getTotalLength().

Referenced by getTotalLength().

## drawChannel()

virtual void juce::AudioThumbnailBase::drawChannel | ( | Graphics & | g,
|  | const Rectangle< int > & | area,
|  | double | startTimeSeconds,
|  | double | endTimeSeconds,
|  | int | channelNum,
|  | float | verticalZoomFactor )

pure virtual

Draws the waveform for a channel.

The waveform will be drawn within the specified rectangle, where startTime and endTime specify the times within the audio file that should be positioned at the left and right edges of the rectangle.

The waveform will be scaled vertically so that a full-volume sample will fill the rectangle vertically, but you can also specify an extra vertical scale factor with the verticalZoomFactor parameter.

Implemented in juce::AudioThumbnail.

References drawChannel().

Referenced by drawChannel().

## drawChannels()

virtual void juce::AudioThumbnailBase::drawChannels | ( | Graphics & | g,
|  | const Rectangle< int > & | area,
|  | double | startTimeSeconds,
|  | double | endTimeSeconds,
|  | float | verticalZoomFactor )

pure virtual

Draws the waveforms for all channels in the thumbnail.

This will call drawChannel() to render each of the thumbnail's channels, stacked above each other within the specified area.

See also
  drawChannel

Implemented in juce::AudioThumbnail.

References drawChannels().

Referenced by drawChannels().

## isFullyLoaded()

virtual bool juce::AudioThumbnailBase::isFullyLoaded | ( |  | ) | const

pure virtual noexcept

Returns true if the low res preview is fully generated.

Implemented in juce::AudioThumbnail.

References isFullyLoaded().

Referenced by isFullyLoaded().

## getNumSamplesFinished()

virtual int64 juce::AudioThumbnailBase::getNumSamplesFinished | ( |  | ) | const

pure virtual noexcept

Returns the number of samples that have been set in the thumbnail.

Implemented in juce::AudioThumbnail.

References getNumSamplesFinished().

Referenced by getNumSamplesFinished().

## getApproximatePeak()

virtual float juce::AudioThumbnailBase::getApproximatePeak | ( |  | ) | const

pure virtual

Returns the highest level in the thumbnail.

Note that because the thumb only stores low-resolution data, this isn't an accurate representation of the highest value, it's only a rough approximation.

Implemented in juce::AudioThumbnail.

References getApproximatePeak().

Referenced by getApproximatePeak().

## getApproximateMinMax()

virtual void juce::AudioThumbnailBase::getApproximateMinMax | ( | double | startTime,
|  | double | endTime,
|  | int | channelIndex,
|  | float & | minValue,
|  | float & | maxValue ) const

pure virtual noexcept

Reads the approximate min and max levels from a section of the thumbnail.

The lowest and highest samples are returned in minValue and maxValue, but obviously because the thumb only stores low-resolution data, these numbers will only be a rough approximation of the true values.

Implemented in juce::AudioThumbnail.

References getApproximateMinMax().

Referenced by getApproximateMinMax().

## getHashCode()

virtual int64 juce::AudioThumbnailBase::getHashCode | ( |  | ) | const

pure virtual

Returns the hash code that was set by setSource() or setReader().

Implemented in juce::AudioThumbnail.

References getHashCode().

Referenced by getHashCode().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited